## mingw-w64-libosmscout-2024.06.02.1-4.src.tar.zst

=== meson_options.txt ===
option('openmp',   type: 'boolean', value: true, description: 'use OpenMP if available')

option('enableGpx',        type: 'boolean', value: true, description: 'Build GPX library')
option('enableImport',     type: 'boolean', value: true, description: 'Build import library')
option('enableTests',      type: 'boolean', value: true, description: 'Build tests')
option('enableMapAgg',     type: 'boolean', value: true, description: 'Build AGG backend')
option('enableMapCairo',   type: 'boolean', value: true, description: 'Build Cairo backend')
option('enableMapDirectX', type: 'boolean', value: true, description: 'Build DirectX backend')
option('enableMapIOSX',    type: 'boolean', value: true, description: 'Build iOS/OS X backend')
option('enableMapOpenGL',  type: 'boolean', value: true, description: 'Build OpenGL backend')
option('enableMapQt',      type: 'boolean', value: true, description: 'Build Qt backend')
option('enableMapSvg',     type: 'boolean', value: true, description: 'Build SVG backend')
option('enableClientQt',   type: 'boolean', value: true, description: 'Build Qt/QML library')
option('enableXML',        type: 'boolean', value: true, description: 'Use libxml2')
option('qtVersion',        type: 'integer', value: 5, min: 5, max: 6, description: 'QT version to use (5 or 6)')

=== Demos/CMakeLists.txt ===
#---- Coverage
osmscout_demo_project(NAME Coverage SOURCES src/Coverage.cpp TARGET OSMScout::OSMScout)

#---- DumpOSS
if(${OSMSCOUT_BUILD_MAP})
  osmscout_demo_project(NAME DumpOSS SOURCES src/DumpOSS.cpp TARGET OSMScout::OSMScout OSMScout::Map)
else()
  message("Skip DumpOSS demo libosmscout-map, is missing.")
endif()

#---- LocationDescription
osmscout_demo_project(NAME LocationDescription SOURCES src/LocationDescription.cpp TARGET OSMScout::OSMScout)

#---- LocationLookup
osmscout_demo_project(NAME LocationLookup SOURCES src/LocationLookup.cpp TARGET OSMScout::OSMScout)

#---- LocationLookupForm
osmscout_demo_project(NAME LocationLookupForm SOURCES src/LocationLookupForm.cpp TARGET OSMScout::OSMScout)

#---- POILookupForm
osmscout_demo_project(NAME POILookupForm SOURCES src/POILookupForm.cpp TARGET OSMScout::OSMScout)

#---- LookupPOI
osmscout_demo_project(NAME LookupPOI SOURCES src/LookupPOI.cpp TARGET OSMScout::OSMScout)

#---- LookupText
if(MARISA_FOUND)
  osmscout_demo_project(NAME LookupText SOURCES src/LookupText.cpp TARGET OSMScout::OSMScout INCLUDES ${MARISA_INCLUDE_DIRS})
else()
  message("Skip LookupText demo, marisa dependency is missing.")
endif()

#---- ResourceConsumption
if(${OSMSCOUT_BUILD_MAP})
	osmscout_demo_project(NAME ResourceConsumption SOURCES src/ResourceConsumption.cpp TARGET OSMScout::OSMScout OSMScout::Map)
else()
	message("Skip ResourceConsumption demo, libosmscout-map is missing.")
endif()

#---- ReverseLocationLookup
osmscout_demo_project(NAME ReverseLocationLookup SOURCES src/ReverseLocationLookup.cpp TARGET OSMScout::OSMScout)

#---- Routing
osmscout_demo_project(NAME Routing SOURCES src/Routing.cpp TARGET OSMScout::OSMScout)

#---- RoutingAnimation
if(${OSMSCOUT_BUILD_MAP_QT})
	osmscout_demo_project(NAME RoutingAnimation SOURCES src/RoutingAnimation.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt Qt::Widgets)
	if(MSVC)
		  visual_studio_qt_helper("RoutingAnimation")
	endif()
	if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
		add_custom_command(TARGET RoutingAnimation
			POST_BUILD
			COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
			COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:RoutingAnimation>/$<TARGET_FILE_NAME:RoutingAnimation>"
		)
	endif()
endif()

#---- Tiler & DrawMapAgg
if(${OSMSCOUT_BUILD_MAP_AGG})
	#---- Tiler
	osmscout_demo_project(NAME Tiler SOURCES src/Tiler.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapAGG)
    if(LIBAGGFT2_LIBRARIES)
        target_link_libraries(Tiler ${LIBAGGFT2_LIBRARIES})
    endif()

	#---- DrawMapAgg
	osmscout_demo_project(NAME DrawMapAgg SOURCES src/DrawMapAgg.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapAGG)
    if(LIBAGGFT2_LIBRARIES)
        target_link_libraries(DrawMapAgg ${LIBAGGFT2_LIBRARIES})
    endif()
else()
	message("Skip Tiler and DrawMapAgg demos, libosmscout-map-agg is missing.")
endif()

#---- DrawMapCairo
if(${OSMSCOUT_BUILD_MAP_CAIRO})
	osmscout_demo_project(NAME DrawMapCairo SOURCES src/DrawMapCairo.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapCairo INCLUDES ${CAIRO_INCLUDE_DIRS} ${CAIRO_INCLUDE_DIRS}/../ ${CAIRO_INCLUDE_DIRS}/cairo)
else()
	message("Skip DrawMapCairo demo, libosmscout-map-cairo is missing.")
endif()

#---- DrawMapQt & ResourceConsumptionQt
if(${OSMSCOUT_BUILD_MAP_QT})
	#---- DrawMapQt
    osmscout_demo_project(NAME DrawMapQt SOURCES src/DrawMapQt.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt Qt::Widgets)
    target_compile_definitions(DrawMapQt PRIVATE ${QtWidgets_DEFINITIONS})
	if(MSVC)
		  visual_studio_qt_helper("DrawMapQt")
	endif()
	if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
		add_custom_command(TARGET DrawMapQt
			POST_BUILD
			COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
			COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:DrawMapQt>/$<TARGET_FILE_NAME:DrawMapQt>"
		)
	endif()

	#---- ResourceConsumptionQt
    osmscout_demo_project(NAME ResourceConsumptionQt SOURCES src/ResourceConsumptionQt.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt Qt::Widgets)
    target_compile_definitions(ResourceConsumptionQt PRIVATE ${QtWidgets_DEFINITIONS})
	if(MSVC)
		  visual_studio_qt_helper("ResourceConsumptionQt")
	endif()
	if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
		add_custom_command(TARGET ResourceConsumptionQt
			POST_BUILD
			COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
			COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:ResourceConsumptionQt>/$<TARGET_FILE_NAME:ResourceConsumptionQt>"
		)
	endif()
else()
	message("Skip ResourceConsumptionQt and DrawMapQt demos, libosmscout-map-qt is missing.")
endif()

#---- ElevationProfileChart
if(${OSMSCOUT_BUILD_CLIENT_QT})
	set(CMAKE_AUTOMOC ON)
	set(CMAKE_AUTORCC ON)

	qt_add_resources(RESOURCE_FILES ../OSMScout2/res.qrc demo.qrc)

	set_property(SOURCE qrc_res.cpp PROPERTY SKIP_AUTOMOC ON)
	set_property(SOURCE qrc_demo.cpp PROPERTY SKIP_AUTOMOC ON)

	#---- ElevationProfileChart
	osmscout_demo_project(NAME ElevationProfileChart
			SOURCES
				src/ElevationProfileChart.cpp
				src/QtDemoApp.cpp
				${RESOURCE_FILES}

				# qml files in CMake sources make it visible in QtCreator
				qml/ElevationProfileChart.qml

			TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt OSMScout::ClientQt Qt::Widgets)
	target_compile_definitions(ElevationProfileChart PRIVATE ${QtWidgets_DEFINITIONS})
	set_target_properties(ElevationProfileChart PROPERTIES
		UNITY_BUILD OFF) # generated code for qt resources use static variables with the same name
	if(MSVC)
		visual_studio_qt_helper("ElevationProfileChart")
	endif()
	if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
		add_custom_command(TARGET ElevationProfileChart
				POST_BUILD
				COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
				COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:ElevationProfileChart>/$<TARGET_FILE_NAME:ElevationProfileChart>"
				)
	endif()

	if (${OSMSCOUT_BUILD_GPX})

		#---- NavigationSimulation
		osmscout_demo_project(NAME NavigationSimulation
			SOURCES
			src/NavigationSimulation.cpp
			include/PositionSimulator.h src/PositionSimulator.cpp
			../OSMScout2/src/Theme.h ../OSMScout2/src/Theme.cpp
			src/QtDemoApp.cpp
			${RESOURCE_FILES}

			# qml files in CMake sources make it visible in QtCreator
			qml/NavigationSimulation.qml

			INCLUDES ../OSMScout2/src/
			TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt OSMScout::ClientQt OSMScout::GPX Qt::Widgets)
		target_compile_definitions(NavigationSimulation PRIVATE ${QtWidgets_DEFINITIONS})
		set_target_properties(NavigationSimulation PROPERTIES
			UNITY_BUILD OFF) # generated code for qt resources use static variables with the same name
		if(MSVC)
			visual_studio_qt_helper("NavigationSimulation")
		endif()
		if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
			add_custom_command(TARGET NavigationSimulation
				POST_BUILD
				COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
				COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:NavigationSimulation>/$<TARGET_FILE_NAME:NavigationSimulation>"
				)
		endif()
	else()
		message("Skip NavigationSimulation demo, libosmscout-gpx is missing.")
	endif()

	#---- RoutingParameters
	osmscout_demo_project(NAME RoutingParameters
		SOURCES
			../OSMScout2/src/Theme.h ../OSMScout2/src/Theme.cpp
			src/RoutingParameters.cpp
			src/QtDemoApp.cpp
			${RESOURCE_FILES}

			# qml files in CMake sources make it visible in QtCreator
			qml/RoutingParameters.qml
			qml/PlaceInput.qml

		INCLUDES ../OSMScout2/src/
		TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapQt OSMScout::ClientQt Qt::Widgets)
	target_compile_definitions(RoutingParameters PRIVATE ${QtWidgets_DEFINITIONS})
	set_target_properties(RoutingParameters PROPERTIES
		UNITY_BUILD OFF) # generated code for qt resources use static variables with the same name
	if(MSVC)
		visual_studio_qt_helper("RoutingParameters")
	endif()
	if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
		add_custom_command(TARGET RoutingParameters
			POST_BUILD
			COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
			COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:RoutingParameters>/$<TARGET_FILE_NAME:RoutingParameters>"
			)
	endif()

	#---- QtWidgetsDemoApp
	osmscout_demo_project(NAME QtWidgetsDemoApp SOURCES src/QtWidgetsDemoApp.cpp TARGET Qt::Widgets OSMScout::ClientQt)
else()
	message("Skip ElevationProfileChart, NavigationSimulation and RoutingParameters QtWidgetsDemoApp demo, libosmscout-client-qt is missing.")
endif()

#---- DrawMapSVG
if(${OSMSCOUT_BUILD_MAP_SVG})
    osmscout_demo_project(NAME DrawMapSVG SOURCES src/DrawMapSVG.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapSVG)
else()
	message("Skip DrawMapSVG demo, libosmscout-map-svg is missing.")
endif()

#---- DrawMapDirectX
if(${OSMSCOUT_BUILD_MAP_DIRECTX})
    osmscout_demo_project(NAME DrawMapDirectX SOURCES src/DrawMapDirectX.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapDirectX ${Direct2D_LIBRARIES} "Shell32.lib")
	if(MSVC)
		set_target_properties(DrawMapDirectX PROPERTIES LINK_FLAGS /SUBSYSTEM:WINDOWS)
	endif()
else()
	message("Skip DrawMapDirectX demo, libosmscout-map-directx is missing.")
endif()

#---- DrawMapOpenGL
if(${OSMSCOUT_BUILD_MAP_OPENGL} AND TARGET glfw)
    osmscout_demo_project(NAME DrawMapOpenGL SOURCES src/DrawMapOpenGL.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapOpenGL glfw)
else()
	message("Skip DrawMapOpenGL demo, libosmscout-map-opengl or glfw is missing.")
endif()

#---- DrawMapOSX
if(APPLE AND NOT IOS)
	if(${OSMSCOUT_BUILD_MAP_IOSX})
		osmscout_demo_project(NAME DrawMapOSX SOURCES src/DrawMapOSX.mm TARGET OSMScout::OSMScout OSMScout::Map OSMScoutMapIOSX INCLUDES ${CMAKE_SOURCE_DIR}/libosmscout-map-iOSX/include ${CMAKE_BINARY_DIR}/libosmscout-map-iOSX/include)
		set_target_properties(DrawMapOSX PROPERTIES
				UNITY_BUILD OFF)
	else()
		message("Skip DrawMapOSX demo, libosmscout-map-iosx is missing.")
	endif()
endif()

#---- GpxPipe & ElevationProfile
if(${LIBXML2_FOUND} AND ${OSMSCOUT_BUILD_GPX})
    #---- GpxPipe
    osmscout_demo_project(NAME GpxPipe SOURCES src/GpxPipe.cpp TARGET OSMScout::OSMScout OSMScout::GPX)

    #---- ElevationProfile
    osmscout_demo_project(NAME ElevationProfile SOURCES src/ElevationProfile.cpp TARGET OSMScout::OSMScout OSMScout::GPX)
else()
    message("Skip GpxPipe and ElevationProfile demos, libxml is missing.")
endif()

#---- Navigation
osmscout_demo_project(NAME Navigation SOURCES src/Navigation.cpp TARGET OSMScout::OSMScout)

#---- NavigationSimulator
osmscout_demo_project(NAME NavigationSimulator SOURCES src/NavigationSimulator.cpp TARGET OSMScout::OSMScout OSMScout::Map)

#---- DrawMapGDI
if(${OSMSCOUT_BUILD_MAP_GDI})
    osmscout_demo_project(NAME DrawMapGDI SOURCES src/DrawMapGDI.cpp TARGET OSMScout::OSMScout OSMScout::Map OSMScout::MapGDI)
    target_compile_definitions(DrawMapGDI PRIVATE _UNICODE UNICODE)
	if(MSVC)
		set_target_properties(DrawMapGDI PROPERTIES LINK_FLAGS /SUBSYSTEM:WINDOWS)
	endif()
else()
	message("Skip DrawMapGDI demo, libosmscout-map-gdi is missing.")
endif()

#---- Srtm
osmscout_demo_project(NAME Srtm SOURCES src/Srtm.cpp TARGET OSMScout::OSMScout)

=== Documentation/CMakeLists.txt ===
if(DOXYGEN_DOT_FOUND)
  set(OSMSCOUT_HAVE_DOT "YES")
  set(OSMSCOUT_DOT_PATH "${DOXYGEN_DOT_EXECUTABLE}")
else()
  set(OSMSCOUT_HAVE_DOT "NO")
  set(OSMSCOUT_DOT_PATH "")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
set(PAGES_FILES Android_Qt.txt Resources.txt StyleSheetSyntax.txt VehiclesAndAccess.txt)
set(PAGES_TITLES "Android/Qt" "Resources" "Style Sheet Syntax" "Vehicles and access")
if(MSVC)
  list(APPEND PAGES_FILES README.VisualStudio.txt)
  list(APPEND PAGES_TITLES "Visual Studio")
endif()
if(MINGW OR MSYS)
  list(APPEND PAGES_FILES README.MSYS2.txt)
  list(APPEND PAGES_TITLES "MSYS2")
endif()
if(APPLE)
  list(APPEND PAGES_FILES README.Apple.txt)
  list(APPEND PAGES_TITLES "Apple")
endif()
if(OSMSCOUT_BUILD_BINDING_JAVA)
  list(APPEND PAGES_FILES README.Java.txt)
  list(APPEND PAGES_TITLES "Java")
endif()
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/pages.dox "/**\n\\mainpage libosmscout\n")
file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/pages.dox "${TEMPFILECONTENT}\nIn addition to API, this guide provides additional information:\n")
list(LENGTH PAGES_FILES PAGES_COUNT)
math(EXPR PAGES_COUNT "${PAGES_COUNT} - 1")
foreach(PAGE_INDEX RANGE 0 ${PAGES_COUNT})
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/pages.dox "- \\ref page${PAGE_INDEX}\n")
endforeach()
file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/pages.dox "\n\n")
foreach(PAGE_INDEX RANGE 0 ${PAGES_COUNT})
  list(GET PAGES_TITLES ${PAGE_INDEX} TEMPFILECONTENT)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/pages.dox "\\page page${PAGE_INDEX} ${TEMPFILECONTENT}\n")
  list(GET PAGES_FILES ${PAGE_INDEX} TEMPFILECONTENT)
  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/${TEMPFILECONTENT} TEMPFILECONTENT)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/pages.dox "${TEMPFILECONTENT}\n\n")
endforeach()
file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/pages.dox "\n*/\n")

add_custom_target(doc ALL
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen"
    VERBATIM)

set_target_properties(doc PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Documentation")

if (WIN32 OR APPLE)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION doc)
elseif (UNIX)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION "share/osmscout/docs")
endif ()

=== Import/CMakeLists.txt ===
set(OSMSCOUT_BUILD_IMPORT ON CACHE INTERNAL "" FORCE)

set(SOURCE_FILES
    src/Import.cpp
)

add_executable(Import ${SOURCE_FILES} ${HEADER_FILES})

set_target_properties(Import PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Tools")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/Config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/include/Config.h)

target_include_directories(Import PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/include)

target_link_libraries(Import OSMScout::Import)

if(OSMSCOUT_BUILD_IMPORT_TOOL_FOR_DISTRIBUTION AND (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX OR CMAKE_COMPILER_IS_GNUCC))
  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++")
endif()
if(WIN32)
	create_win32_tool_resource(Import)
endif()

install(TARGETS Import
        RUNTIME DESTINATION bin
        BUNDLE DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

=== OSMScoutOpenGL/CMakeLists.txt ===
set(SOURCE_FILES
	src/OSMScoutOpenGL.cpp
)

add_executable(OSMScoutOpenGL ${SOURCE_FILES})

set_target_properties(OSMScoutOpenGL PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Tools")

target_include_directories(OSMScoutOpenGL PRIVATE
	Freetype::Freetype
)

target_link_libraries(OSMScoutOpenGL
	OSMScout::OSMScout
	OSMScout::Map
	OSMScout::MapOpenGL
	OpenGL::GL
	glfw
)

install(TARGETS OSMScoutOpenGL
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

=== PublicTransportMap/CMakeLists.txt ===
set(SOURCE_FILES
    src/PublicTransportMap.cpp
)

add_executable(PublicTransportMap ${SOURCE_FILES})

set_target_properties(PublicTransportMap PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Tools")

target_link_libraries(PublicTransportMap OSMScout::OSMScout)

if(WIN32)
	create_win32_tool_resource(PublicTransportMap)
endif()

install(TARGETS PublicTransportMap
        RUNTIME DESTINATION bin
		BUNDLE DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

=== Tests/CMakeLists.txt ===
#---- AccessParse
osmscout_test_project(NAME AccessParse SOURCES src/AccessParse.cpp)

#---- AsyncProcessing
osmscout_test_project(NAME AsyncProcessing SOURCES src/AsyncProcessing.cpp)

#---- AsyncWorker
osmscout_test_project(NAME AsyncWorker SOURCES src/AsyncWorker.cpp)

#---- Bearing
osmscout_test_project(NAME Bearing SOURCES src/Bearing.cpp)

#---- BitsAndBytesNeeded
osmscout_test_project(NAME BitsAndBytesNeeded SOURCES src/BitsAndBytesNeeded.cpp)

#---- ByteTest
osmscout_test_project(NAME ByteTest SOURCES src/ByteTest.cpp)

#---- CachePerformance
osmscout_test_project(NAME CachePerformance SOURCES src/CachePerformance.cpp COMMAND --size 1000)

#---- CalculateResolution
osmscout_test_project(NAME CalculateResolution SOURCES src/CalculateResolution.cpp)

#---- CancelableFuture
osmscout_test_project(NAME CancelableFuture SOURCES src/CancelableFuture.cpp)

#---- CmdLineParsing
osmscout_test_project(NAME CmdLineParsing SOURCES src/CmdLineParsing.cpp)

#---- ColorParse
osmscout_test_project(NAME ColorParse SOURCES src/ColorParse.cpp)

#---- CoordinateEncoding
osmscout_test_project(NAME CoordinateEncoding SOURCES src/CoordinateEncoding.cpp COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/data/testregion")

#---- Latch
osmscout_test_project(NAME Latch SOURCES src/Latch.cpp)

#---- LocationLookup
osmscout_test_project(NAME LocationLookupTest SOURCES src/LocationServiceTest.cpp src/SearchForLocationByStringTest.cpp src/SearchForLocationByFormTest.cpp src/SearchForPOIByFormTest.cpp TARGET OSMScout::Test OSMScout::Import)
set_source_files_properties(src/SearchForLocationByStringTest.cpp src/SearchForLocationByFormTest.cpp src/SearchForPOIByFormTest.cpp src/LocationServiceTest.cpp PROPERTIES SKIP_UNITY_BUILD_INCLUSION TRUE)
set_tests_properties(LocationLookupTest PROPERTIES ENVIRONMENT "TESTS_TOP_DIR=${CMAKE_CURRENT_SOURCE_DIR};TESTS_TMP_DIR=${CMAKE_CURRENT_BINARY_DIR}")
set_tests_properties(LocationLookupTest PROPERTIES UNITY_BUILD FALSE)

#---- NumberSetPerformance
osmscout_test_project(NAME NumberSetPerformance SOURCES src/NumberSetPerformance.cpp)

#---- OpeningHours
osmscout_test_project(NAME OpeningHours SOURCES src/OpeningHours.cpp)

#---- ReaderScannerPerformance
osmscout_test_project(NAME ReaderScannerPerformance SOURCES src/ReaderScannerPerformance.cpp COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/data/testregion")

#---- MultiDBRouting
osmscout_test_project(NAME MultiDBRouting SOURCES src/MultiDBRouting.cpp COMMAND 50.412 14.534 50.424 14.6013 "${CMAKE_CURRENT_SOURCE_DIR}/data/testregion")

#---- ThreadedDatabase
if(${OSMSCOUT_BUILD_MAP} AND TARGET OSMScout::Map)
	osmscout_test_project(NAME ThreadedDatabase SOURCES src/ThreadedDatabase.cpp TARGET OSMScout::Map COMMAND --threads 100 --iterations 1000 "${CMAKE_CURRENT_SOURCE_DIR}/data/testregion" "${CMAKE_CURRENT_SOURCE_DIR}/../stylesheets/standard.oss")
else()
	message("Skip ThreadedDatabase test, libosmscout-map is missing.")
endif()

#---- TextLookupTest
if(MARISA_FOUND)
	osmscout_demo_project(NAME TextLookupTest SOURCES src/TextLookupTest.cpp TARGET OSMScout::OSMScout OSMScout::OSMScout)

	add_test(NAME TextLookupTest-vysoka
		COMMAND TextLookupTest
		--expected-results 5
		"${CMAKE_CURRENT_SOURCE_DIR}/data/testregion"
		"vysoka"
		)

	add_test(NAME TextLookupTest-Vysoká
		COMMAND TextLookupTest
		--expected-results 5
		"${CMAKE_CURRENT_SOURCE_DIR}/data/testregion"
		"Vysoká"
		)

	add_test(NAME TextLookupTest-bosyne
		COMMAND TextLookupTest
		--expected-results 1
		"${CMAKE_CURRENT_SOURCE_DIR}/data/testregion"
		"bosyne"
		)
else()
	message("Skip TextLookupTest test, Marisa library is missing.")
endif()

#---- Thread
osmscout_test_project(NAME Thread SOURCES src/Thread.cpp)

#---- DrawTextQt
if(${OSMSCOUT_BUILD_MAP_QT} AND TARGET OSMScout::MapQt)
	set(src_files src/DrawTextQt.cpp include/DrawWindow.h)
	qt_wrap_cpp(src_files include/DrawWindow.h)
	osmscout_test_project(NAME DrawTextQt SOURCES ${src_files} TARGET OSMScout::Map OSMScout::MapQt Qt::Widgets SKIPTEST)
else()
	message("Skip DrawTextQt test, libosmscout-map-qt is missing.")
endif()

#---- Geometry
osmscout_test_project(NAME Geometry SOURCES src/Geometry.cpp)

#---- HeaderCheck
osmscout_test_project(NAME HeaderCheck SOURCES src/HeaderCheck.cpp)
set_tests_properties(HeaderCheck PROPERTIES ENVIRONMENT "SOURCE_ROOT=${CMAKE_SOURCE_DIR}")

#---- WaterIndex
if(${OSMSCOUT_BUILD_IMPORT} AND TARGET OSMScout::Import)
	osmscout_test_project(NAME WaterIndex SOURCES src/WaterIndex.cpp TARGET OSMScout::Import)
else()
	message("Skip WaterIndex test, libosmscout-import is missing.")
endif()

#---- WorkQueue
osmscout_test_project(NAME WorkQueue SOURCES src/WorkQueue.cpp)

#---- MapRotate
if(NOT MINGW AND NOT MSYS)
	if(${OSMSCOUT_BUILD_MAP} AND TARGET OSMScout::Map)
		osmscout_test_project(NAME MapRotate SOURCES src/MapRotate.cpp TARGET OSMScout::Map)
	else()
		message("Skip MapRotate test, libosmscout-map is missing.")
	endif()
endif()

#---- EncodeNumber
osmscout_test_project(NAME EncodeNumber SOURCES src/EncodeNumber.cpp)

#---- FeatureLabelTest
osmscout_test_project(NAME FeatureLabelTest SOURCES src/FeatureLabelTest.cpp)

#---- File
osmscout_test_project(NAME File SOURCES src/File.cpp)

#---- FileScannerWriter
osmscout_test_project(NAME FileScannerWriter SOURCES src/FileScannerWriter.cpp)

#---- GeoCoordParse
osmscout_test_project(NAME GeoCoordParse SOURCES src/GeoCoordParse.cpp)

#---- NumberSet
osmscout_test_project(NAME NumberSet SOURCES src/NumberSet.cpp)

#---- ScanConversion
osmscout_test_project(NAME ScanConversion SOURCES src/ScanConversion.cpp)

#---- ScreenMask
if(${OSMSCOUT_BUILD_MAP} AND TARGET OSMScout::Map)
  osmscout_test_project(NAME ScreenMaskTest SOURCES src/ScreenMaskTest.cpp TARGET OSMScout::Map)
else()
	message("Skip ScreenMask test, libosmscout-map is missing.")
endif()

#---- StringUtils
osmscout_test_project(NAME StringUtils SOURCES src/StringUtils.cpp)

#---- StdByteTest
osmscout_test_project(NAME StdByteTest SOURCES src/StdByteTest.cpp)

#---- Signal
osmscout_test_project(NAME Signal SOURCES src/Signal.cpp)

#---- TilingTest
osmscout_test_project(NAME TilingTest SOURCES src/TilingTest.cpp)

#---- TimeParse
osmscout_test_project(NAME TimeParse SOURCES src/TimeParse.cpp)

#---- WStringStringConversion
osmscout_test_project(NAME WStringStringConversion SOURCES src/WStringStringConversion.cpp)

#---- TransPolygon
osmscout_test_project(NAME TransPolygon SOURCES src/TransPolygon.cpp)

#---- GeoBox
osmscout_test_project(NAME GeoBox SOURCES src/GeoBox.cpp)

#---- OSTAndOSSCheck
if(${OSMSCOUT_BUILD_MAP} AND TARGET OSMScout::Map)
	osmscout_test_project(NAME OSTAndOSSCheck SOURCES src/OSTAndOSSCheck.cpp TARGET OSMScout::Map SKIPTEST)

	set(STYLESHEETS
		standard.oss
		winter-sports.oss
		boundaries.oss
		railways.oss
		motorways.oss
		public-transport.oss
		cycle.oss)

	foreach(STYLESHEET ${STYLESHEETS})
		add_test(NAME CheckStyleSheet-${STYLESHEET}
			COMMAND OSTAndOSSCheck
			--warning-as-error
			${CMAKE_CURRENT_SOURCE_DIR}/../stylesheets/map.ost
			${CMAKE_CURRENT_SOURCE_DIR}/../stylesheets/${STYLESHEET})
	endforeach()
else()
    message("Skip OSTAndOSSCheck test, libosmscout-map is missing.")
endif()

#---- PerformanceTest
if(${OSMSCOUT_BUILD_MAP})
	osmscout_demo_project(NAME PerformanceTest SOURCES src/PerformanceTest.cpp TARGET OSMScout::OSMScout OSMScout::Map)
	target_include_directories(PerformanceTest PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/include/PerformanceTest)

	set(PERFORMANCE_TEST_DRIVERS noop none)

	if(${OSMSCOUT_BUILD_MAP_CAIRO})
		target_link_libraries(PerformanceTest OSMScout::MapCairo)
		set(HAVE_LIB_OSMSCOUTMAPCAIRO 1)
		set(PERFORMANCE_TEST_DRIVERS ${PERFORMANCE_TEST_DRIVERS} cairo)
	endif()
	if(${OSMSCOUT_BUILD_MAP_QT})
		target_link_libraries(PerformanceTest OSMScout::MapQt Qt::Widgets)
		set(HAVE_LIB_OSMSCOUTMAPQT 1)
		if(MSVC)
			visual_studio_qt_helper("PerformanceTest")
		endif()
		if(OSMSCOUT_INSTALL_QT_DLL AND TARGET Qt::windeployqt)
			add_custom_command(TARGET PerformanceTest
				POST_BUILD
				COMMAND set PATH=%PATH%$<SEMICOLON>${qt_install_prefix}/bin
				COMMAND Qt::windeployqt --dir "${CMAKE_BINARY_DIR}/windeployqt" "$<TARGET_FILE_DIR:PerformanceTest>/$<TARGET_FILE_NAME:PerformanceTest>"
				)
		endif()
		set(PERFORMANCE_TEST_DRIVERS ${PERFORMANCE_TEST_DRIVERS} Qt)
	endif()
	if(${OSMSCOUT_BUILD_MAP_AGG})
		target_link_libraries(PerformanceTest OSMScout::MapAGG)
		set(HAVE_LIB_OSMSCOUTMAPAGG 1)
		set(PERFORMANCE_TEST_DRIVERS ${PERFORMANCE_TEST_DRIVERS} agg)
	endif()
	if(${OSMSCOUT_BUILD_MAP_OPENGL} AND TARGET glfw)
		target_link_libraries(PerformanceTest OSMScout::MapOpenGL glfw)
		set(HAVE_LIB_OSMSCOUTMAPOPENGL 1)
		set(PERFORMANCE_TEST_DRIVERS ${PERFORMANCE_TEST_DRIVERS} opengl)
	endif()
	if(${OSMSCOUT_BUILD_MAP_GDI})
		target_link_libraries(PerformanceTest OSMScout::MapGDI)
		set(HAVE_LIB_OSMSCOUTMAPGDI 1)
		set(PERFORMANCE_TEST_DRIVERS ${PERFORMANCE_TEST_DRIVERS} dgi)
	endif()

	option(PERF_TEST_GPERFTOOLS_USAGE "Enable Gperftools in Performance test" ${GPERFTOOLS_USAGE})
	if(${PERF_TEST_GPERFTOOLS_USAGE})
		target_include_directories(PerformanceTest PRIVATE ${GPERFTOOLS_INCLUDE_DIRS})
		target_link_libraries(PerformanceTest ${GPERFTOOLS_LIBRARIES})
	endif()
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/PerformanceTestConfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/include/PerformanceTest/config.h)

	set(STYLESHEETS
		standard.oss
		winter-sports.oss
		boundaries.oss
		railways.oss
		motorways.oss
		public-transport.oss
		cycle.oss)

	foreach(DRIVER ${PERFORMANCE_TEST_DRIVERS})
		foreach(STYLESHEET ${STYLESHEETS})
			add_test(NAME PerformanceTest-${DRIVER}-${STYLESHEET}
				COMMAND PerformanceTest
				--debug
				--driver ${DRIVER}
				--icons "${CMAKE_CURRENT_SOURCE_DIR}/../libosmscout/data/icons/svg/standard"
				--font "${CMAKE_CURRENT_SOURCE_DIR}/../libosmscout-map-opengl/data/fonts/LiberationSans-Regular.ttf"
				"${CMAKE_CURRENT_SOURCE_DIR}/../Tests/data/testregion"
				"${CMAKE_CURRENT_SOURCE_DIR}/../stylesheets/${STYLESHEET}"
				50.3806 14.5418 50.3806 14.5418)
		endforeach()
	endforeach()

else()
	message("Skip PerformanceTest test, libosmscout-map is missing.")
endif()

#---- LabelPathTest
if(${OSMSCOUT_BUILD_MAP} AND TARGET OSMScout::Map)
	osmscout_test_project(NAME LabelPathTest SOURCES src/LabelPathTest.cpp TARGET OSMScout::Map)
else()
	message("Skip LabelPathTest, libosmscout-map is missing.")
endif()

#---- Base64
osmscout_test_project(NAME Base64 SOURCES src/Base64.cpp)

#---- CoordBufferTest
osmscout_test_project(NAME CoordBufferTest SOURCES src/CoordBufferTest.cpp)

#---- ClientQtThreading
if(${OSMSCOUT_BUILD_CLIENT_QT} AND TARGET OSMScout::MapQt AND TARGET OSMScout::ClientQt)
	set(src_files src/ClientQtThreading.cpp)
	qt_wrap_cpp(src_files include/ClientQtThreading.h)
	osmscout_test_project(NAME ClientQtThreading SOURCES ${src_files} TARGET OSMScout::Map OSMScout::MapQt OSMScout::ClientQt Qt::Widgets SKIPTEST)
else()
	message("Skip ClientQtThreading test, libosmscout-client-qt is missing.")
endif()

#---- QtFileDownloader
if(${OSMSCOUT_BUILD_CLIENT_QT} AND TARGET OSMScout::MapQt AND TARGET OSMScout::ClientQt)
	set(src_files src/QtFileDownloader.cpp)
	qt_wrap_cpp(src_files include/DownloaderTest.h)
	osmscout_test_project(NAME QtFileDownloader SOURCES ${src_files} TARGET OSMScout::Map OSMScout::MapQt OSMScout::ClientQt Qt::Widgets SKIPTEST)
else()
	message("Skip QtFileDownloader test, libosmscout-client-qt is missing.")
endif()

#---- ScreenBox
osmscout_test_project(NAME ScreenBox SOURCES src/ScreenBox.cpp)

#---- SunriseSunsetTest
osmscout_test_project(NAME SunriseSunsetTest SOURCES src/SunriseSunsetTest.cpp)

#---- PolygonCenterTest
osmscout_test_project(NAME PolygonCenterTest SOURCES src/PolygonCenter.cpp)

#---- MercatorProjection
osmscout_test_project(NAME MercatorProjectionTest SOURCES src/MercatorProjection.cpp)

=== libosmscout-binding/CMakeLists.txt ===
if(OSMSCOUT_BUILD_BINDING_JAVA)
  if(NOT SWIG_FOUND)
    message(SEND_ERROR "swig is required for java binding")
  endif()
  if(NOT JNI_FOUND)
    message(SEND_ERROR "A JDK is required for java binding")
  endif()

  include(${SWIG_USE_FILE})
  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/Java/src/main/java/net/sf/libosmscout/osmscout)
  file(MAKE_DIRECTORY ${CMAKE_SWIG_OUTDIR})
  # See https://github.com/swig/swig/issues/568
  set(CMAKE_SWIG_FLAGS -c++ -package net.sf.libosmscout.osmscout -features autodoc=1 -DSWIGWORDSIZE64 -I${CMAKE_CURRENT_SOURCE_DIR}/src/swig -I${CMAKE_CURRENT_SOURCE_DIR}/../libosmscout/include -outdir ${CMAKE_SWIG_OUTDIR})
  if(MSVC)
    set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -Fmicrosoft)
  endif()
  set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/src/swig/osmscout/libosmscout.i PROPERTIES CPLUSPLUS ON)
  swig_add_library(osmscout_binding_java
    LANGUAGE Java
    SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/swig/osmscout/libosmscout.i)
  swig_link_libraries(osmscout_binding_java OSMScout ${JNI_LIBRARIES})
  target_include_directories(osmscout_binding_java PRIVATE
    include
    ${CMAKE_CURRENT_BINARY_DIR}/include
    ${JNI_INCLUDE_DIRS}
    ${JAVA_INCLUDE_PATH})
  target_link_libraries(osmscout_binding_java
    ${OSMSCOUT_TARGET}
    ${JNI_LIBRARIES})
  set_property(TARGET osmscout_binding_java PROPERTY CXX_STANDARD 17)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")

  install(TARGETS osmscout_binding_java
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION bin
    ARCHIVE DESTINATION lib)
  install(DIRECTORY ${OSMSCOUT_BASE_DIR_SOURCE}/Java DESTINATION binding)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Java DESTINATION binding FILES_MATCHING PATTERN "*.java" PATTERN "private" EXCLUDE)
endif()

if(OSMSCOUT_BUILD_BINDING_CSHARP)
  if(NOT SWIG_FOUND)
    message(SEND_ERROR "swig is required for c# binding")
  endif()

  include(${SWIG_USE_FILE})
  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/CSharp)
  file(MAKE_DIRECTORY ${CMAKE_SWIG_OUTDIR})
  set(CMAKE_SWIG_FLAGS -c++ -features autodoc=1 -I${CMAKE_CURRENT_SOURCE_DIR}/src/swig -I${CMAKE_CURRENT_SOURCE_DIR}/../libosmscout/include -outdir ${CMAKE_SWIG_OUTDIR})
  if(MSVC)
    set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -Fmicrosoft)
  endif()
  set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/src/swig/osmscout/libosmscout.i PROPERTIES CPLUSPLUS ON)
  swig_add_module(osmscout_binding_csharp csharp ${CMAKE_CURRENT_SOURCE_DIR}/src/swig/osmscout/libosmscout.i)
  swig_link_libraries(osmscout_binding_csharp OSMScout)
  target_include_directories(osmscout_binding_csharp PRIVATE
    include
    ${CMAKE_CURRENT_BINARY_DIR}/include)
  target_link_libraries(osmscout_binding_csharp
          ${OSMSCOUT_TARGET})
  set_property(TARGET osmscout_binding_csharp PROPERTY CXX_STANDARD 17)

  install(TARGETS osmscout_binding_csharp
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION bin
    ARCHIVE DESTINATION lib)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/CSharp DESTINATION binding FILES_MATCHING PATTERN "*.cs" PATTERN "private" EXCLUDE)
endif()

=== libosmscout-client/CMakeLists.txt ===
set(HEADER_FILES
  include/osmscoutclient/json/json.hpp
  include/osmscoutclient/json/json_fwd.hpp
  include/osmscoutclient/AdminRegionInfo.h
  include/osmscoutclient/DBInstance.h
  include/osmscoutclient/DBJob.h
  include/osmscoutclient/DBThread.h
  include/osmscoutclient/LocationInfo.h
  include/osmscoutclient/MapDirectory.h
  include/osmscoutclient/MapManager.h
  include/osmscoutclient/MapProvider.h
  include/osmscoutclient/ClientImportExport.h
  include/osmscoutclient/OnlineTileProvider.h
  include/osmscoutclient/POILookupModule.h
  include/osmscoutclient/Settings.h
  include/osmscoutclient/VoiceProvider.h
)

set(SOURCE_FILES
  src/osmscoutclient/DBInstance.cpp
  src/osmscoutclient/DBJob.cpp
  src/osmscoutclient/DBThread.cpp
  src/osmscoutclient/MapDirectory.cpp
  src/osmscoutclient/MapManager.cpp
  src/osmscoutclient/MapProvider.cpp
  src/osmscoutclient/OnlineTileProvider.cpp
  src/osmscoutclient/POILookupModule.cpp
  src/osmscoutclient/Settings.cpp
  src/osmscoutclient/VoiceProvider.cpp
)

set(EXCLUDE_HEADER)

osmscout_library_project(
	NAME OSMScoutClient
	ALIAS Client
	OUTPUT_NAME "osmscout_client"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR "osmscoutclient"
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutclient/ClientFeatures.h.cmake
	FEATURE ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutclient/ClientFeatures.h
	TARGET OSMScout::OSMScout OSMScout::Map
	SKIP_HEADER
)

if (HAVE_STD_EXECUTION)
	target_link_libraries(OSMScoutClient TBB::tbb)
endif()

if(OpenMP_CXX_FOUND)
	target_link_libraries(OSMScoutClient OpenMP::OpenMP_CXX)
endif()

if(MARISA_FOUND)
	target_include_directories(OSMScoutClient PUBLIC ${MARISA_INCLUDE_DIRS})
	target_link_libraries(OSMScoutClient ${MARISA_LIBRARIES})
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutClient PROPERTIES
        FRAMEWORK TRUE
        FRAMEWORK_VERSION C
        MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
        #MACOSX_FRAMEWORK_INFO_PLIST Info.plist
        PUBLIC_HEADER     "${HEADER_FILES}"
        CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
        OUTPUT_NAME "OSMScoutClient")
endif()

if(WIN32)
	target_link_libraries(OSMScoutClient Ws2_32.lib)
endif()

if(NOT EXCLUDE_HEADER)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutclient DESTINATION include FILES_MATCHING REGEX "/.*\\.h|.*\\.hpp$" PATTERN "private" EXCLUDE)
else()
	set(_exclude PATTERN "private" EXCLUDE)
	foreach(ef ${EXCLUDE_HEADER})
		set(_exclude ${_exclude} PATTERN ${ef} EXCLUDE)
	endforeach()
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutclient DESTINATION include FILES_MATCHING REGEX "/.*\\.h|.*\\.hpp$" ${_exclude})
endif()
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutclient/ClientFeatures.h DESTINATION include/osmscout)

=== libosmscout-extern/CMakeLists.txt ===
if(OSMSCOUT_BUILD_EXTERN_MATLAB)
  if(NOT MATLAB_FOUND)
    message(SEND_ERROR "MATLAB is required for MATLAB mex function")
  endif()

  matlab_add_mex (NAME "osmscoutmx" SRC "src/matlab/libosmscoutmx.cpp" "src/matlab/libosmscoutmx.h")

  if(MSVC)
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/osmscoutmxd.def "LIBRARY osmscoutmxd.${Matlab_MEX_EXTENSION}\n\nEXPORTS\n    mexFunction\n")
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/osmscoutmx.def "LIBRARY osmscoutmx.${Matlab_MEX_EXTENSION}\n\nEXPORTS\n    mexFunction\n")
    set_target_properties(osmscoutmx PROPERTIES LINK_FLAGS -DEF:"${CMAKE_CURRENT_BINARY_DIR}/osmscoutmx.def")
    set_target_properties(osmscoutmx PROPERTIES LINK_FLAGS_DEBUG -DEF:"${CMAKE_CURRENT_BINARY_DIR}/osmscoutmxd.def")
	create_win32_dll_resource(osmscoutmx "osmscoutmx")
  endif()

  target_link_libraries(osmscoutmx OSMScout::OSMScout)
  target_compile_definitions(osmscoutmx PRIVATE -DOSMSCOUT_MATLAB_EXPORT_SYMBOLS -DMATLAB_MEX_FILE)

  if(${OSMSCOUT_BUILD_MAP_CAIRO})
    target_link_libraries(osmscoutmx OSMScout::Map OSMScout::MapCairo)
    target_compile_definitions(osmscoutmx PRIVATE -DOSMSCOUT_MAP_CAIRO)
  endif()

  set_target_properties(osmscoutmx PROPERTIES VERSION ${OSMSCOUT_LIBRARY_VERSION} SOVERSION ${OSMSCOUT_LIBRARY_VERSION} FOLDER "Extern")

  install(TARGETS osmscoutmx
    RUNTIME DESTINATION bin/matlab
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)
endif()

=== libosmscout-gpx/CMakeLists.txt ===
set(HEADER_FILES
    include/osmscoutgpx/GpxFile.h
    include/osmscoutgpx/GPXImportExport.h
    include/osmscoutgpx/Route.h
    include/osmscoutgpx/Track.h
    include/osmscoutgpx/Waypoint.h
    include/osmscoutgpx/TrackPoint.h
    include/osmscoutgpx/TrackSegment.h
    include/osmscoutgpx/Utils.h
    include/osmscoutgpx/Extensions.h
	${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutgpx/GPXFeatures.h
)

set(SOURCE_FILES
    src/osmscoutgpx/GpxFile.cpp
    src/osmscoutgpx/Track.cpp
    src/osmscoutgpx/TrackSegment.cpp
    src/osmscoutgpx/Utils.cpp
    src/osmscoutgpx/Extensions.cpp
)

if(TARGET LibXml2::LibXml2)
    list(APPEND HEADER_FILES
        include/osmscoutgpx/Import.h
        include/osmscoutgpx/Export.h
    )
    list(APPEND SOURCE_FILES
        src/osmscoutgpx/Import.cpp
        src/osmscoutgpx/Export.cpp
    )
endif()

osmscout_library_project(
	NAME OSMScoutGPX
	ALIAS GPX
	OUTPUT_NAME "osmscout_gpx"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR "osmscoutgpx"
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutgpx/GPXFeatures.h.cmake
	FEATURE ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutgpx/GPXFeatures.h
	TARGET OSMScout::OSMScout
)

if(TARGET LibXml2::LibXml2)
    target_link_libraries(OSMScoutGPX LibXml2::LibXml2)
endif()

if (TARGET Iconv::Iconv)
	target_link_libraries(OSMScoutGPX Iconv::Iconv)
endif()

if (TARGET ZLIB::ZLIB)
	target_link_libraries(OSMScoutGPX ZLIB::ZLIB)
endif()

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutGPX PROPERTIES
		FRAMEWORK TRUE
		FRAMEWORK_VERSION C
  		MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
  		#MACOSX_FRAMEWORK_INFO_PLIST Info.plist
  		PUBLIC_HEADER     "${HEADER_FILES}"
  		CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
		OUTPUT_NAME "OSMScoutGPX")
endif()

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscout DESTINATION include FILES_MATCHING PATTERN "*.h" PATTERN "private" EXCLUDE)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/include/osmscoutgpx/GPXFeatures.h DESTINATION include/osmscout)

=== libosmscout-map-agg/CMakeLists.txt ===
set(HEADER_FILES
    include/osmscoutmapagg/MapAggImportExport.h
    include/osmscoutmapagg/MapAggFeatures.h
    include/osmscoutmapagg/MapPainterAgg.h
)

set(SOURCE_FILES
    src/osmscoutmapagg/MapPainterAgg.cpp
)

osmscout_library_project(
	NAME OSMScoutMapAGG
	ALIAS MapAGG
	OUTPUT_NAME "osmscout_map_agg"
	SOURCE ${SOURCE_FILES}
	HEADER ${HEADER_FILES}
	INCLUDEDIR "osmscoutmapagg"
	INCLUDES ${LIBAGG_INCLUDE_DIRS}
	TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/include/osmscoutmapagg/MapAggFeatures.h.cmake
	TARGET OSMScout::OSMScout OSMScout::Map ${LIBAGG_LIBRARIES} ${LIBAGGFT2_LIBRARIES} Freetype::Freetype
)
target_include_directories(OSMScoutMapAGG INTERFACE ${LIBAGG_INCLUDE_DIRS})

if(APPLE AND OSMSCOUT_BUILD_FRAMEWORKS)
	set_target_properties(OSMScoutMapAGG PROPERTIES
  		FRAMEWORK TRUE
  		FRAMEWORK_VERSION C
  		MACOSX_FRAMEWORK_IDENTIFIER com.cmake.dynamicFramework
  		#MACOSX_FRAMEWORK_INFO_PLIST Info.plist
  		PUBLIC_HEADER     "${HEADER_FILES}"
  		CODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer"
		OUTPUT_NAME "OSMScoutMapAGG")
endif()

=== PKGBUILD ===
# Maintainer: Adrian Jaekel <adrian at arteco dot de>

_realname=libosmscout
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2024.06.02.1
pkgrel=4
pkgdesc="A Library for offline map rendering, routing and location lookup based on OpenStreetMap data (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/Framstag/libosmscout"
license=('spdx:LGPL-2.0-only')
depends=("${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-freeglut"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-glfw"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-glm"
         "${MINGW_PACKAGE_PREFIX}-harfbuzz"
         "${MINGW_PACKAGE_PREFIX}-iconv"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-marisa"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
         "${MINGW_PACKAGE_PREFIX}-qt6-multimedia"
         "${MINGW_PACKAGE_PREFIX}-qt6-positioning"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-clang-libs"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools")
# imagemagick also installs "bin/import.exe"
conflicts=("${MINGW_PACKAGE_PREFIX}-imagemagick")
source=(https://github.com/Framstag/libosmscout/releases/download/v${pkgver}/libosmscout-${pkgver}.tar.xz
        001-fix-install-destinations.patch)
sha256sums=('6dc4929e24fac27b4a24683599ec46b0faedd77251729a11bd098f670fcaec7e'
            '1b57cf69903dacea4a6854991b83c9523a9f23b98ad39a7b773462802d8860ab')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-install-destinations.patch
}

build() {
  mkdir "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  if check_option "debug" "y"; then
    _build_type="Debug"
  else
    _build_type="Release"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=${_build_type} \
    -DOSMSCOUT_BUILD_TESTS=OFF \
    -DOSMSCOUT_BUILD_DEMOS=OFF \
    -DOSMSCOUT_INSTALL_QT_DLL=OFF \
    -DDirect2D_D2D1_LIBRARY=${MINGW_PREFIX}/lib/libd2d1.a \
    -DDirect2D_DWRITE_LIBRARY=${MINGW_PREFIX}/lib/libdwrite.a \
    -DQT_VERSION_PREFERRED=6 \
    "../${_realname}-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
